> For the complete documentation index, see [llms.txt](https://docs.zkbob.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zkbob.com/implementation/client-library-sdk/full-mode-operations/fee-estimations.md).

# Fee Estimations

## <mark style="background-color:green;">Estimate Transaction Fee</mark>

Calculate the relayer fee amount for the provided transaction configuration. A transaction request may produce several transactions, with the following method you have an ability to display fee details

```typescript
async feeEstimate(
    transfersGwei: bigint[],
    txType: TxType,
    withdrawSwap: bigint = 0n,
    updateState: boolean = true
): Promise<FeeAmount>
```

<details>

<summary>Related Methods</summary>

* [atomicTxFee(txType, withdrawSwap)](/implementation/client-library-sdk/account-less-mode-operations/transaction-fees.md#estimating-transaction-typical-fee)

</details>

### Parameters

* `transfersGwei` - a set of transfer amounts (ignored for all transactions except with `txType == TxType.Transfer`)
* `txType` is transaction type (a member of [TxType](/implementation/client-library-sdk/common-types.md#transaction-type) enum)
* `withdrawSwap` is an optional amount of tokens to swap in the withdraw transaction. This may influence the typical withdraw transaction cost due to the extra fee component (ignored for other transaction types).
* `updateState` - update the state before fee estimation if `true` (fee may depends on account and notes configuration)

### Returns

`Promise` returns [FeeAmount](/implementation/client-library-sdk/common-types.md#fee-amount-required-for-request) object with fee estimation

### Example

```typescript
const res = await zkClient.feeEstimate([100000000000, 12000000000], TxType.Transfer);
console.log(`The transfer will take ${res.txCnt} tx(s) and requires ${res.total} fee`);
// output: The transfer will take 1 tx(s) and requires 263573104 fee
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.zkbob.com/implementation/client-library-sdk/full-mode-operations/fee-estimations.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
